* Action routines for demo              v0.00   Oct 1987  J.R.Oakley  QJUMP
*
        section prog
*
        include 'flp2_wman_keys'
        include 'flp2_wman_wwork'
        include 'flp2_wman_wstatus'
        include 'flp2_demo_keys'
        include 'flp2_demo_sms'
        include 'flp2_qdos_pt'
*
        xref.s  mv_beepn
*
        xref    dsu_bepc
*
        xdef    mea_quit
        xdef    mea_all
        xdef    mea_move
        xdef    mea_beep
        xdef    mea_subw
*
        xdef    mea_mus
*
mea_quit
        moveq   #pt..can,d4
mea_subw      
        moveq   #0,d0
        rts
*
*       Do the BEEP item: this consists of making a noise and updating
*       the count.
*
mea_beep
        move.l  a3,-(sp)                ; keep item for later
        lea     ipcom(pc),a3            ; standard beep is OK
        moveq   #sms.hdop,d0
        trap    #1                      ; do it
*
        addq.w  #1,mv_beepn(a6)         ; increment count
        jsr     dsu_bepc(pc)            ; and change string appropriately
*
        moveq   #$ffffff00+%11111101,d3 ; re-draw second information window
        jsr     wm.idraw(a2)            ; do it
*
        move.l  (sp)+,a3                ; restore item
        bra     dac_exrd                ; and exit, re-drawing it
*
*       Change status of all items in menu sub-window
*
mea_all
        move.l  a0,-(sp)
        move.w  wwl_item(a3),d0         ; get item number of ALL
        move.b  ws_litem(a1,d0.w),d0    ; and therefore ALL's status 
*
        move.l  ww_pappl(a4),a3         ; point to application sub-window list
        move.l  4(a3),a3                ; and to the second sub-window $$$ MAGIC
*
        move.l  wwa_mstt(a3),a1         ; point to status block
        move.l  wwa_rowl(a3),a2         ; point to row list
        move.w  wwa_nrow(a3),d1         ; there are this many rows
        bra.s   aal_srse
aal_srsl
        move.w  wwa_ncol(a3),d2         ; there should be this mnay columns
        move.l  (a2)+,a0                ; start of row is here
        move.l  (a2)+,d3                ; end is here              $$$ positive!
        bra.s   aal_sstd
aal_sstl
        move.w  wwm_item(a0),d4         ; get item number
        tst.b   0(a1,d4.w)              ; what is its status?
        bgt.s   aal_sste                ; unavailable, do nothing
        cmp.b   0(a1,d4.w),d0           ; already the same as ALL?
        beq.s   aal_sste                ; yes, do nothing
        move.b  d0,0(a1,d4.w)           ; no, set same as ALL...
        bset    #wsi..chg,0(a1,d4.w)    ; ...but with change bit set
aal_sste
        add.w   #wwm.olen,a0            ; next object
        cmp.w   a0,d3                   ; off end?
aal_sstd
        dble    d2,aal_sstl             ; go until last column
aal_srse
        dbra    d1,aal_srsl             ; and until last row
*
*       The item statuses are now set, so we can re-draw
*
        move.l  (sp),a0                 ; restore the smashed channel ID
        move.l  dv_wmvec(a6),a2         ; and the window manager vector
        moveq   #-1,d3                  ; and do a selective...
        jsr     wm.mdraw(a2)            ; ...menu re-draw
*
*       We must clear the change bits
*
        move.l  wwa_mstt(a3),a1         ; point to status block
        move.l  wwa_rowl(a3),a2         ; point to row list
        move.w  wwa_nrow(a3),d1         ; there are this many rows
        bra.s   aal_crse
aal_crsl
        move.w  wwa_ncol(a3),d2         ; there should be this many columns
        move.l  (a2)+,a0                ; start of row is here
        move.l  (a2)+,d3                ; end is here              $$$ positive!
        bra.s   aal_cstd
aal_cstl
        move.w  wwm_item(a0),d4         ; get item number
        bclr    #wsi..chg,0(a1,d4.w)    ; and clear change bit
aal_cste
        add.w   #wwm.olen,a0            ; next object
        cmp.w   a0,d3                   ; off end?
aal_cstd
        dble    d2,aal_cstl             ; go until last column
aal_crse
        dbra    d1,aal_crsl             ; and last row
*
        move.l  (sp)+,a0
        moveq   #0,d4                   ; no event
        moveq   #0,d0
        rts
*
*       Come here when the MOVE item is hit: we need to move the window
*       and then re-draw the item.
*
mea_move
        bset    #pt..wmov,wsp_weve(a1)  ; request move
        jsr     wm.chwin(a2)            ; call move routine
        bclr    #pt..wmov,wsp_weve(a1)  ; reset move request
*
dac_exrd
        move.w  wwl_item(a3),d2             ; get the item number
        move.b  #wsi.mkav,ws_litem(a1,d2.w) ; set item to available
        moveq   #-1,d3                      ; do a selective...
        jsr     wm.ldraw(a2)                ; ...loose item re-draw
        bclr    #wsi..chg,ws_litem(a1,d2.w) ; clear change bit
*
        moveq   #0,d4                       ; no event
        moveq   #0,d0
        rts
*
*       Come here when the music sub-window is hit
*
musreg  reg     d1/d5/d7
mea_mus
        moveq   #-1,d3                  ; next timeout is long
        tst.b   wsp_kprs(a1)            ; is there a key pressed?
        bne.s   msh_toot                ; yes, make a joyful sound
        tst.w   d2                      ; hit with which key?
        ble.s   msh_exit                ; none, ignore it
*
msh_toot
        movem.l musreg,-(sp)
        sub.l   ww_xorg(a4),d1          ; make co-ordinates relative to main...
        sub.l   wwa_xorg(a3),d1         ; ...and sub-window
        sub.w   #ipclen,sp              ; make space for IPC command
        move.l  sp,a1                   ; copy to here
        lea     ipcom(pc),a2            ; from here
        moveq   #ipclen,d0              ; this many bytes
        bra.s   msh_cple
msh_cpll
        move.b  (a2)+,(a1)+             ; copy part of command
msh_cple
        dbra    d0,msh_cpll
*
        move.l  sp,a3                       ; IPC command is here
        move.b  notetab(pc,d1.w),pitch1(a3) ; set pitch according to height
        swap    d1                          ; get horizontal offset
        mulu    #100,d1                     ; multiply up to get it sensible
        addq.w  #1,d1                       ; ensure it isn't 0!
        rol.w   #8,d1                       ; swap high and low bytes
        move.w  d1,length(a3)               ; fill it in
*
        moveq   #sms.hdop,d0            ; beep a bit
        trap    #1
*
        add.w   #ipclen,sp              ; remove stack frame
        movem.l (sp)+,musreg            ; and exit
msh_exit
        moveq   #0,d0
        rts
*
ipcom
        dc.b    $0a,$08                 ; sound, 8 parameters
        dc.l    %1010101010101010       ; all 8 bits of each
pitch1  equ     *-ipcom
        dc.b    10,0                    ; pitch1=10
        dc.b    0,0                     ; no interval
length  equ     *-ipcom
        dc.b    1000&$FF,1000>>8        ; length=1000
        dc.b    0,0                     ; no step, wrap, random or fuzz
        dc.b    1                       ; no reply
*
        ds.w    0
ipclen  equ     *-ipcom                 ; IPC command length better be even
*
notetab
        dc.b    2,3,4,6,8,10
        dc.b    11,14,17,19,22,26
        dc.b    30,33,38,44,47,54
        dc.b    62,71,76,86,98,104
        dc.b    118,134,152,161,182,206
*
        end
