* Setup routine for demo                v0.00   Oct 1987  J.R.Oakley  QJUMP
*
        section prog
*
        include 'flp2_demo_keys'
        include 'flp2_demo_sms'
        include 'flp2_wman_keys'
        include 'flp2_wman_wwork'
        include 'flp2_wman_wstatus'
        include 'flp2_qdos_io'
        include 'flp2_qdos_pt'
*
*       External symbols to do with the window definition...
*
        xref.s  wst_demo
        xref.s  mcy_avml
        xref    men_demo
*
*       ...and the variable information within it...
*
        xref    met_bepy
        xref.s  mv_beepn
        xref.s  mv_beeps
*
*       ...and how to set it up
*
        xref    dsu_fset
        xref    dsu_bepc
*
*       Job name and things
*
        bra.s   dsi_init
        nop
        nop
        dc.w    $4afb                   ; name flag
        dc.w    dsi_nend-*-2            ; name length
        dc.b    'Demo program'          ; name characters
dsi_nend
        ds.w    0                       ; make sure start address is even
*
*       The start of the code
*
dsi_init
        lea     dv_end(a6,a4.l),a6      ; data area is here
        move.l  a6,a4                   ; clear from here
        moveq   #0,d0
dsi_cllp
        move.l  d0,(a4)+
        cmp.l   a4,a7                   ; clear up to bottom of stack
        bgt.s   dsi_cllp
*
*       We also need a screen channel to get the Window Manager vector
*       from and subsequently for drawing in.
*
        lea     condef(pc),a0           ; a Console device...
        moveq   #myself,d1              ; ...for my...
        moveq   #ioa.kexc,d3            ; ...exclusive use...
        moveq   #ioa.open,d0            ; ...is to be opened
        trap    #2
        tst.l   d0
        bne.s   dsi_kill                ; whoops
        move.l  a0,dv_chid(a6)          ; keep a copy of the ID, in case
*
        moveq   #iop.pinf,d0            ; get Pointer INFormation
        moveq   #forever,d3             ; sometime, don't care when
        trap    #3
        tst.l   d0
        bne.s   dsi_kill                ; no Pointer Interface, give up
        move.l  a1,dv_wmvec(a6)         ; keep Window Manager Vector
*
*       The beep count being variable, we have to set it up in the
*       status area and set the pointer to it.
*
        lea     mv_beeps+2(a6),a3       ; the characters will be here
        lea     met_bepy(pc),a0         ; the string starts like this
        move.w  (a0)+,d0                ; there's this much of it
        bra.s   dsi_cbhe                ; copy beep header
dsi_cbhl
        move.b  (a0)+,(a3)+             ; character by character
dsi_cbhe
        dbra    d0,dsi_cbhl
*
        clr.w   mv_beepn(a6)            ; start with a count of zero
*
*       Initialise the control definition
*
        move.w  #2,mcy_avml(a6)            ; two sections
        move.w  #1,mcy_avml+wss_ssiz+2(a6) ; with one row in each
        move.w  #1,mcy_avml+wss_ssiz+wss.ssln+2(a6)
        move.w  #2*6+20,mcy_avml+wss_spos+wss.ssln+2(a6) ; offset of second
*
*       Now we can set up the working definition for the first time,
*       using the default size specified in the window definition.
*
        move.l  dv_chid(a6),a0          ; this is our primary
        lea     wst_demo(a6),a1         ; the status area is here
        move.l  dv_wmvec(a6),a2         ; the window manager is here
        lea     men_demo(pc),a3         ; the window definition is here
        moveq   #0,d1                   ; use default size
        jsr     dsu_fset(pc)            ; do first setup
        bne.s   dsi_kill                ; whoops
        jsr     dsu_bepc(pc)            ; and complete the beep information
*
*       Now we have a standard format definition, we can position
*       the window: it's a primary, so WM.PRPOS is the vector to use.
*
        moveq   #-1,d1                  ; position it wherever the pointer is
        jsr     wm.prpos(a2)            ; position the window
        bne.s   dsi_kill
*
        jsr     wm.wdraw(a2)            ; and draw the contents
        bne.s   dsi_kill
*
*       Now we can see the window in all its glory, we can request
*       user input to do things with it. 
*
dsi_rptr
        jsr     wm.rptr(a2)             ; find out what's to be done
        bne.s   dsi_kill
        btst    #pt..can,wsp_weve(a1)   ; did he hit QUIT?
        beq.s   dsi_rptr                ; no, so don't stop
*
*       Come here if there's a fatal error or the user hits QUIT
*
dsi_kill
        move.l  d0,d3                   ; this was the error
        moveq   #myself,d1              ; this job...
        moveq   #sms.frjb,d0            ; ...is to be removed
        trap    #1
*
*       Definition of console to be opened
*
condef
        dc.w    3,'con'
*
        end

