* Setup routine for demo                v0.00   Oct 1987  J.R.Oakley  QJUMP
*
        section prog
*
        include 'flp2_demo_keys'
        include 'flp2_demo_sms'
        include 'flp2_wman_keys'
        include 'flp2_wman_wwork'
*
        xref.l  wwa.demo
        xref.s  mv_beepn
        xref.s  mv_beeps
*
        xref    met_bepy
        xref    met_bept
*
        xdef    dsu_rset
        xdef    dsu_fset
        xdef    dsu_bepc
*
*       Allocate or return common heap
*
archreg reg     d1-d3/a1-a3
ut_achp
        moveq   #sms.achp,d0
        bra.s   dsu_chpe
ut_rchp
        moveq   #sms.rchp,d0
dsu_chpe
        movem.l archreg,-(sp)
        moveq   #myself,d2              ; allocate for myself
        trap    #1
        tst.l   d0                      ; return condition codes set
        movem.l (sp)+,archreg
        rts
*
lsztab
        dc.l    wwa.demo
*
*       Come here to set up the working definition, when there
*       is one already - used when we want to change size.
*
*       Registers:
*               Entry                           Exit
*       A4      old working definition          as for FSET
*
*       All other registers as for FSET
*
dsu_rset
        move.l  a0,-(sp)                ; keep channel ID
        jsr     wm.unset(a2)            ; unset the current definition
        move.l  a4,a0
        bsr     ut_rchp                 ; and throw away its heap
        move.l  (sp)+,a0     
*
*       Come here to set up a working definition for the first time
*
*       Registers:
*               Entry                           Exit
*       D1      size required                   x,y size
*       A0      channel ID                      smashed
*       A1      status area                     preserved
*       A2      window manager vector           preserved
*       A3      window definition               smashed
*       A4                                      working definition
*
dsu_fset
awdreg  reg     d1/a0
        movem.l awdreg,-(sp)            ; keep size required and channel ID
        jsr     wm.fsize(a2)            ; find the size we'll get
        add.w   d2,d2                   ; make an...
        add.w   d2,d2                   ; ...offset into the size table
        move.l  lsztab(pc,d2.w),d1      ; get space required
        bsr     ut_achp                 ; and allocate it
        move.l  a0,a4                   ; it's the working definition
        movem.l (sp)+,awdreg            
        bne.s   dsu_exit                ; ...oops, it doesn't exist
        move.l  a4,dv_wwork(a6)         ; keep a copy 
*
*       Now we've found the space, we can convert the
*       window definition into a working definition.
*
        jsr     wm.setup(a2)            ; set up the Working Definition
        bne.s   dsu_exit                ; something went wrong
*
*       The beep count being variable, it's kept in the status area,
*       so we have to set the pointer to it.
*
        move.l  ww_pinfo(a4),a0          ; information sub-windows are here
        move.l  wwi_pobl+wwi.elen(a0),a0 ; second one's information list 
        lea     mv_beeps(a6),a3          ; string will be here
        move.l  a3,wwo_pobj(a0)          ; point first information object at it
        tst.l   d0                       ; set no error
*
dsu_exit
        rts
*
*       This setup routine is used to keep the count of times
*       the BEEP item has been used.  The number is the status area
*       variable MV_BEEPN is converted to ASCII and "inserted" in 
*       the rest of the string.
*
*       Registers:
*               Entry                           Exit
*       D0-D3                                   smashed
*       A0                                      smashed
*       A1      pointer to status area          preserved
*       A3                                      smashed
*
bepcreg reg     a1/a2
*
dsu_bepc
        movem.l bepcreg,-(sp)
        move.w  met_bepy(pc),d0         ; length of first part of string
        lea     mv_beeps+2(a6,d0.w),a0  ; point to where number goes
        move.w  #mv_beepn,a1            ; and where number is (in binary)
*
        sub.l   a6,a0                   ; things for conversion are A6-rel
        move.w  cv.iwdec,a2             ; convert an integer to decimal
        jsr     (a2)                    ; this can't fail
*
        add.l   a6,a0                   ; point to end of string, absolutely
        lea     met_bept(pc),a2         ; and to trailer
        move.w  (a2)+,d0                ; trailer is this long
        bra.s   dsu_cbte                ; copy beep trailer
dsu_cbtl
        move.b  (a2)+,(a0)+             ; copy one character
dsu_cbte
        dbra    d0,dsu_cbtl
*
        cmp.w   #1,mv_beepn(a6)         ; just one beep so far?
        beq.s   dsu_adfs                ; yes, just add full stop
        move.b  #'s',(a0)+              ; no, add 's' 
dsu_adfs
        move.b  #'.',(a0)+              ; add '.'
        lea     mv_beeps+2(a6),a2       ; start of string is here
        sub.l   a2,a0                   ; so new length is this
        move.w  a0,mv_beeps(a6)         ; fill it in
*
        movem.l (sp)+,bepcreg
        rts
*
        end
